package ru.bitheaven.donpayinteg;

import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.event.lifecycle.v1.ServerTickEvents;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.bitheaven.donpayinteg.command.DPI;
import ru.bitheaven.donpayinteg.config.ConfigHandler;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicReference;

public class DonPayInteg implements ModInitializer {
    public static final String MOD_ID = "donpayinteg";
    public static final String NAME = "DonatePayIntegration";
    public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);
    public static List<String> commands = new ArrayList<>();

    @Override
    public void onInitialize() {
        LOGGER.info("Mod [{}] is loading!", NAME);

        ConfigHandler.register();

        DPI.register();

        AtomicInteger i = new AtomicInteger();
        AtomicInteger j = new AtomicInteger();
        AtomicReference<DonateThread> thread = new AtomicReference<>(new DonateThread());

        ServerTickEvents.START_SERVER_TICK.register((world) -> {
            if(!thread.get().isAlive()) {
                if(i.getAndIncrement() % (20 * 15) == 0) {
                    thread.set(new DonateThread());
                    thread.get().start();
                }
            }

            if(j.getAndIncrement() % (20 * 2) == 0) {
                if (!commands.isEmpty()) {
                    world.getCommandManager().executeWithPrefix(world.getCommandSource(), commands.get(0));
                    commands.remove(0);
                }
            }
        });
    }
}
